/*
   Class Name:

      CBone/CBoneVertex.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      These classes represents a skeleton bone for vertex skinning and a class that
      represents a vertex with all the necessary information for skinning.
*/


#include"CBone.h"


CBone::CBone() : parent(0), length(0)
{

}


void CBone::SetBone(unsigned int P, float L)
{
   // Set the bone data.
   parent = P; length = L;
}


void CBone::SetBone(unsigned int P, float L, CMatrix4x4 R, CMatrix4x4 A)
{
   // Set the bone data.
   parent = P; length = L; relative = R; absolute = A;
}


CBoneVertex::CBoneVertex() : r(0), g(0), b(0), a(0), numBones(0)
{
   // Initialize all member data.
   boneIndex[0] = 0; boneIndex[1] = 0; boneIndex[2] = 0; boneIndex[3] = 0;
   weights[0] = 0; weights[1] = 0; weights[2] = 0; weights[3] = 0;
}


void CBoneVertex::SetVertex(CVector4 p, CVector4 n, int b1, int b2, int b3, int b4,
                            float w1, float w2, float w3, float w4,
                            int R, int G, int B, int A, int numB)
{
   // Set vertex data based on information sent in.
   pos = p;
   normal = n;
   boneIndex[0] = b1; boneIndex[1] = b2; boneIndex[2] = b3; boneIndex[3] = b4;
   weights[0] = w1; weights[1] = w2; weights[2] = w3; weights[3] = w4;
   r = R; g = G; b = B; a = A;
   numBones = numB;
}


// Copyright May 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com