/*
   Class Name:

      CBone/CBoneVertex.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      These classes represents a skeleton bone for vertex skinning and a class that
      represents a vertex with all the necessary information for skinning.
*/


#ifndef CBONE_H
#define CBONE_H


#include"CMatrix.h"


class CBone
{
   public:
      CBone();
      
      void SetBone(unsigned int P, float L);
      void SetBone(unsigned int P, float L, CMatrix4x4 R, CMatrix4x4 A);

      unsigned int parent;
      float length;

      CMatrix4x4 relative;
      CMatrix4x4 absolute;
};


class CBoneVertex
{
   public:
      CBoneVertex();

      void SetVertex(CVector4 p, CVector4 n, int b1, int b2, int b3, int b4,
                     float w1, float w2, float w3, float w4, int R, int G,
                     int B, int A, int numB);
      
      
      CVector4 pos;
      CVector4 normal;
      
      int boneIndex[4];
      float weights[4];
      int numBones;

      int r, g, b, a;
};

#endif


// Copyright May 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com